/**
 * @author fenris
 */
type int = number;
/**
 * @author fenris
 */
type float = number;
/**
 * @author fenris
 */
type type_time = {
    hours: int;
    minutes: int;
    seconds: int;
};
declare var process: any;
declare var require: any;
declare class Buffer {
    constructor(x: string, modifier?: string);
    toString(modifier?: string): string;
}
declare namespace lib_plankton.base {
    /**
     * @author fenris
     */
    function environment(): string;
}
/**
 * @author fenris
 */
type type_pseudopointer<type_value> = {
    value: type_value;
};
/**
 * @author fenris
 */
declare function pseudopointer_null<type_value>(): type_pseudopointer<type_value>;
/**
 * @author fenris
 */
declare function pseudopointer_make<type_value>(value: type_value): type_pseudopointer<type_value>;
/**
 * @author fenris
 */
declare function pseudopointer_isset<type_value>(pseudopointer: type_pseudopointer<type_value>): boolean;
/**
 * @author fenris
 */
declare function pseudopointer_read<type_value>(pseudopointer: type_pseudopointer<type_value>): type_value;
/**
 * @author fenris
 */
declare function pseudopointer_write<type_value>(pseudopointer: type_pseudopointer<type_value>, value: type_value): void;
/**
 * @author fenris
 */
declare var instance_verbosity: int;
/**
 * @desc the ability to check for equality with another element of the same domain
 * @author fenris
 */
interface interface_collatable<type_value> {
    /**
     * @author fenris
     */
    _collate(value: type_value): boolean;
}
/**
 * @author fenris
 */
declare function instance_collate<type_value>(value1: (type_value & {
    _collate?: ((value: type_value) => boolean);
}), value2: type_value): boolean;
/**
 * @desc the ability to compare with another element of the same domain for determining if the first is "smaller than or equal to" the latter
 * @author fenris
 */
interface interface_comparable<type_value> {
    /**
     * @author fenris
     */
    _compare(value: type_value): boolean;
}
/**
 * @author fenris
 */
declare function instance_compare<type_value>(value1: (type_value & {
    _compare: ((value: type_value) => boolean);
}), value2: type_value): boolean;
/**
 * @desc the ability to create an exact copy
 * @author fenris
 */
interface interface_cloneable<type_value> {
    /**
     * @author fenris
     */
    _clone(): type_value;
}
/**
 * @author fenris
 */
declare function instance_clone<type_value>(value: (type_value & {
    _clone?: (() => type_value);
})): type_value;
/**
 * @author fenris
 */
interface interface_hashable {
    /**
     * @author fenris
     */
    _hash(): string;
}
/**
 * @desc the ability to generate a string out of the element, which identifies it to a high degree
 * @author fenris
 */
declare function instance_hash<type_value>(value: (type_value & {
    _hash?: (() => string);
})): string;
/**
 * @author fenris
 */
interface interface_showable {
    /**
     * @author fenris
     */
    _show(): string;
}
/**
 * @desc the ability to map the element to a textual representation (most likely not injective)
 * @author fenris
 */
declare function instance_show<type_value>(value: (type_value & {
    _show?: (() => string);
})): string;
/**
 * @author frac
 */
interface interface_decorator<type_core> {
    /**
     * @author frac
     */
    core: type_core;
}
/**
 * @author frac
 */
declare class class_observer {
    /**
     * @author frac
     */
    protected counter: int;
    /**
     * @author frac
     */
    protected actions: {
        [id: string]: (information: Object) => void;
    };
    /**
     * @author frac
     */
    protected buffer: Array<Object>;
    /**
     * @author frac
     */
    constructor();
    /**
     * @author frac
     */
    empty(): boolean;
    /**
     * @author frac
     */
    flush(): void;
    /**
     * @author frac
     */
    set(id: string, action: (information: Object) => void): void;
    /**
     * @author frac
     */
    del(id: string): void;
    /**
     * @author frac
     */
    add(action: (information: Object) => void): void;
    /**
     * @author frac
     */
    notify(information?: Object, delayed?: boolean): void;
    /**
     * @author frac
     */
    rollout(): void;
}
/**
 * @author frac
 */
/**
 * @author frac
 */
/**
 * @author frac
 */
declare class class_error extends Error {
    /**
     * @author frac
     */
    protected suberrors: Array<Error>;
    /**
     * @author frac
     */
    protected mess: string;
    /**
     * @author frac
     */
    constructor(message: string, suberrors?: Array<Error>);
    /**
     * @override
     * @author frac
     */
    toString(): string;
}
declare namespace lib_plankton.base {
    /**
     * returns the current UNIX timestamp
     *
     * @author fenris
     */
    function get_current_timestamp(rounded?: boolean): int;
    /**
     */
    function object_merge(core: Record<string, any>, mantle: Record<string, any>): Record<string, any>;
}
declare namespace lib_plankton.pod {
    /**
     * @author fenris
     */
    type type_pod<type_value> = {
        kind: ("empty" | "filled");
        value?: type_value;
    };
    /**
     * @author fenris
     */
    function make_empty<type_value>(): type_pod<type_value>;
    /**
     * @author fenris
     */
    function make_filled<type_value>(value: type_value): type_pod<type_value>;
    /**
     * whether the pod is filled
     *
     * @author fenris
     */
    function is_filled<type_value>(pod: type_pod<type_value>): boolean;
    /**
     * return the value, stored in the pod-wrapper
     *
     * @author fenris
     */
    function cull<type_value>(pod: type_pod<type_value>): type_value;
    /**
     * to pass on a empty-pod or to use a filled-pod
     *
     * @author fenris
     */
    function propagate<type_value, type_value_>(pod: type_pod<type_value>, function_: ((value: type_value) => type_value_)): type_pod<type_value_>;
    /**
     * @author fenris
     */
    function distinguish<type_value, type_result>(pod: type_pod<type_value>, function_empty: (() => type_result), function_filled: ((value: type_value) => type_result)): type_result;
    /**
     */
    function show<type_value>(pod: type_pod<type_value>, options?: {
        show_value?: ((value: type_value) => string);
    }): string;
}
declare namespace lib_plankton.pod {
    /**
     */
    class class_pod<type_value> {
        private subject;
        private constructor();
        is_empty(): boolean;
        is_filled(): boolean;
        cull(): type_value;
        show(show_value?: any): string;
        toString(): string;
        propagate<type_value_>(function_: ((value: type_value) => type_value_)): class_pod<type_value_>;
        distinguish<type_result>(function_empty: (() => type_result), function_filled: ((value: type_value) => type_result)): type_result;
    }
}
declare namespace lib_plankton.call {
    /**
     * @desc hacked class for postfix function application
     * @author fenris
     */
    class class_valuewrapper<type_value> {
        /**
         * @author fenris
         */
        protected value: type_value;
        /**
         * @desc [constructor]
         * @author fenris
         */
        constructor(value: type_value);
        /**
         * @desc [accessor] applies a function and returns a new valuewrapper
         * @author fenris
         */
        pass<type_value_>(function_: (value: type_value) => type_value_): class_valuewrapper<type_value_>;
        /**
         * @desc [accessor] gives the wrapped value
         * @author fenris
         */
        extract(): type_value;
    }
    /**
     * @desc shortcut for constructing a valuewrapper-object
     * @author fenris
     */
    function vw<type_value>(value: type_value): class_valuewrapper<type_value>;
    /**
     * @author fenris
     */
    function use<type_input, type_output>(input: type_input, function_: (input: type_input) => type_output): type_output;
    /**
     * @desc just the identity; useful for some callbacks etc.
     * @author fenris
     */
    function id<type_value>(x: type_value): type_value;
    /**
     * @desc composes two functions (i.e. returns a function that return the result of the successive execution of both input-functions)
     * @param {function} function_f
     * @param {function} function_g
     * @author fenris
     */
    function compose<type_x, type_y, type_z>(function_f: (type_x: any) => type_y, function_g: (type_y: any) => type_z): (value: type_x) => type_z;
    /**
     * @desc transforms a function with sequential input into a function with leveled input; example: add(2,3) = curryfy(add)(2)(3)
     * @param {function} f
     * @param {int} n (don't set manually)
     * @return {function} the currified version of the in put function
     * @author fenris
     */
    function curryfy(f: Function, n?: int): Function;
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    type type_executor<type_result, type_reason> = ((resolve: (result?: type_result) => any, reject?: (reason?: type_reason) => void) => void);
    /**
     * @author fenris
     */
    function executor_resolve<type_result, type_reason>(result: type_result): type_executor<type_result, type_reason>;
    /**
     * @author fenris
     */
    function executor_reject<type_result, type_reason>(reason: type_reason): type_executor<type_result, type_reason>;
    /**
     * @author fenris
     */
    function executor_transform<type_result_from, type_error_from, type_result_to, type_error_to>(executor: type_executor<type_result_from, type_error_from>, transform_result: (result_from: type_result_from) => type_result_to, transform_reason: (error_from: type_error_from) => type_error_to): type_executor<type_result_to, type_error_to>;
    /**
     * @author fenris
     */
    function executor_transform_default<type_result_from, type_result_to>(executor: type_executor<type_result_from, Error>, transform_result: (result_from: type_result_from) => type_result_to, wrap_string?: string): type_executor<type_result_to, Error>;
    /**
     * @author fenris
     */
    function executor_compose_sequential<type_result_first, type_result_second, type_reason>(first: type_executor<type_result_first, type_reason>, second: (result: type_result_first) => type_executor<type_result_second, type_reason>): type_executor<type_result_second, type_reason>;
    /**
     * @author fenris
     */
    function executor_chain<type_state, type_error>(state: type_state, executors: Array<(state: type_state) => type_executor<type_state, type_error>>): type_executor<type_state, type_error>;
    /**
     * @author fenris
     */
    function executor_first<type_result, type_reason>(executors: Array<type_executor<type_result, type_reason>>): type_executor<type_result, Array<type_reason>>;
    /**
     * @author fenris
     */
    function executor_condense<type_element>(executors: Array<type_executor<type_element, Error>>): type_executor<Array<type_element>, Error>;
    /**
     * @author fenris
     * @deprecated use condense
     */
    function executor_filter<type_element>(executors: Array<type_executor<type_element, Error>>, predicate: (element: type_element) => boolean): type_executor<Array<type_element>, Error>;
    /**
     * @author fenris
     * @deprecated use condense
     */
    function executor_map<type_element1, type_element2>(executors: Array<type_executor<type_element1, Error>>, transformator: (element1: type_element1) => type_element2): type_executor<Array<type_element2>, Error>;
    /**
     * @author fenris
     * @deprecated use condense
     */
    function executor_reduce<type_element, type_result>(executors: Array<type_executor<type_element, Error>>, initial: type_result, accumulator: (result: type_result, element: type_element) => type_result): type_executor<type_result, Error>;
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    type type_promise<type_result, type_reason> = Promise<type_result>;
    /**
     * @author fenris
     */
    function promise_reject<type_result, type_reason>(reason: type_reason): type_promise<type_result, type_reason>;
    /**
     * @author fenris
     */
    function promise_resolve<type_result, type_reason>(result: type_result): type_promise<type_result, type_reason>;
    /**
     * @author fenris
     */
    function promise_make<type_result, type_reason>(executor: (resolve: (result?: type_result) => void, reject: (reason?: type_reason) => void) => void): type_promise<type_result, type_reason>;
    /**
     * @author fenris
     */
    function promise_then_close<type_result, type_reason>(promise: type_promise<type_result, type_reason>, resolver: (result: type_result) => void, rejector: (reason: type_reason) => void): void;
    /**
     * @author fenris
     */
    function promise_then_append<type_result, type_reason, type_result_>(promise: type_promise<type_result, type_reason>, resolver: (result: type_result) => type_promise<type_result_, type_reason>, rejector?: (reason: type_reason) => type_promise<type_result_, type_reason>): type_promise<type_result_, type_result>;
    /**
     * @author fenris
     */
    function promise_all<type_result, type_reason>(promises: Array<type_promise<type_result, type_reason>>): type_promise<Array<type_result>, type_reason>;
    /**
     * @author fenris
     */
    function promise_chain<type_result, type_reason>(promises: Array<(input: type_result) => type_promise<type_result, type_reason>>, start?: type_result): type_promise<type_result, type_reason>;
    /**
     * @author fenris
     */
    function promise_condense<type_element, type_reason>(promises: Array<() => type_promise<type_element, type_reason>>): type_promise<Array<type_element>, type_reason>;
    /**
     * @author fenris
     */
    function promise_group<type_reason>(promises: {
        [name: string]: () => type_promise<any, type_reason>;
    }, serial?: boolean): type_promise<{
        [name: string]: any;
    }, type_reason>;
    /**
     * @author fenris
     */
    function promise_wrap<type_result_inner, type_result_outer, type_reason>(promise: type_promise<type_result_inner, type_reason>, transformator_result: (reason: type_result_inner) => type_result_outer, transformator_reason?: (reason: type_reason) => type_reason): type_promise<type_result_outer, type_reason>;
    /**
     * @author fenris
     */
    /**
     * @author fenris
     */
    /**
     * @author fenris
     */
    function promise_attach<type_reason>(state: {
        [name: string]: any;
    }, promise: type_promise<any, type_reason>, name: string): type_promise<{
        [name: string]: any;
    }, type_reason>;
    /**
     * @author fenris
     */
    function promise_delay<type_result, type_reason>(promise: type_promise<type_result, type_reason>, delay: int): type_promise<type_result, type_reason>;
    /**
     * @author fenris
     */
    function promise_to_executor<type_result, type_reason>(promise: type_promise<type_result, type_reason>): type_executor<type_result, type_reason>;
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    type type_initializer_state = int;
    const initializer_state_initial: type_initializer_state;
    const initializer_state_waiting: type_initializer_state;
    const initializer_state_successful: type_initializer_state;
    const initializer_state_failed: type_initializer_state;
    /**
     * @author fenris
     */
    type type_initializer<type_result, type_reason> = {
        fetcher: () => type_promise<type_result, type_reason>;
        state?: type_initializer_state;
        queue: Array<{
            resolve: (result?: type_result) => void;
            reject: (reason?: type_reason) => void;
        }>;
        result?: type_result;
        reason?: type_reason;
    };
    /**
     * @author fenris
     */
    function initializer_make<type_result, type_reason>(fetcher: () => type_promise<type_result, type_reason>): type_initializer<type_result, type_reason>;
    /**
     * @author fenris
     */
    function initializer_reset<type_result, type_reason>(subject: type_initializer<type_result, type_reason>): void;
    /**
     * @author fenris
     */
    function initializer_state<type_result, type_reason>(subject: type_initializer<type_result, type_reason>): type_initializer_state;
    /**
     * @author fenris
     */
    function initializer_get<type_result, type_reason>(subject: type_initializer<type_result, type_reason>): type_promise<type_result, type_reason>;
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    type type_deferral<type_input, type_output> = {
        representation: (input: type_input) => Promise<type_output>;
    };
    /**
     * @author fenris
     * @desc activates the deferral and handles its output according to a given procedure
     * @param {(value : type_value)=>void} procedure a function which receives the output of the deferral as argument
     */
    function deferral_use<type_input, type_output>(deferral: type_deferral<type_input, type_output>, input: type_input, procedure: (output: type_output) => void): void;
    /**
     * @author fenris
     * @desc creates a deferral-subject (similar to "new Promise", where "convey" reflects "resolve"/"reject")
     */
    function deferral_make<type_input, type_output>(handler: (input: type_input, convey: (output: type_output) => void) => void): type_deferral<type_input, type_output>;
    /**
     * @author fenris
     * @desc wraps a simple function into a deferral (similar to "Promise.resolve"/"Promise.reject")
     */
    function deferral_wrap<type_input, type_output>(function_: (input: type_input) => type_output): type_deferral<type_input, type_output>;
    /**
     * @author fenris
     */
    function deferral_id<type_value>(): type_deferral<type_value, type_value>;
    /**
     * @author fenris
     */
    function deferral_const<type_value>(value: type_value): type_deferral<type_value, type_value>;
    /**
     * @author fenris
     */
    function deferral_delay<type_output>(output: type_output, delay: int): type_deferral<any, type_output>;
    /**
     * @author fenris
     * @desc connects two deferrals to form a new one; the output of the first is taken as input for the second
     *     (similar to "Promise.then" when passing a function which returns a new promise)
     * @param {type_deferral<type_value1>} first a simple deferral
     * @param {(value1 : type_value1)=>type_deferral<type_value2>} second a function depending from a value returning a deferral
     */
    function deferral_compose_serial<type_input, type_between, type_output>(first: type_deferral<type_input, type_between>, second: type_deferral<type_between, type_output>): type_deferral<type_input, type_output>;
    /**
     * @author fenris
     */
    function deferral_compose_parallel<type_input, type_output_left, type_output_right>({ "left": deferral_left, "right": deferral_right, }: {
        left: type_deferral<type_input, type_output_left>;
        right: type_deferral<type_input, type_output_right>;
    }): type_deferral<type_input, {
        left: type_output_left;
        right: type_output_right;
    }>;
    /**
     * @author fenris
     * @desc repeatedly applied serial composition
     */
    function deferral_chain<type_value>(members: Array<type_deferral<type_value, type_value>>): type_deferral<type_value, type_value>;
    /**
     * @author fenris
     */
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    class class_deferral<type_input, type_output> {
        /**
         * @author fenris
         */
        private subject;
        /**
         * @author fenris
         */
        private constructor();
        /**
         * @author fenris
         */
        private static _cram;
        /**
         * @author fenris
         */
        private static _tear;
        /**
         * @author fenris
         */
        static make<type_input, type_output>(handler: (input: type_input, convey: (value: type_output) => void) => void): class_deferral<type_input, type_output>;
        /**
         * @author fenris
         */
        use(input: type_input, procedure: (value: type_output) => void): void;
        /**
         * @author fenris
         */
        compose_serial<type_output_>(second: class_deferral<type_output, type_output_>): class_deferral<type_input, type_output_>;
        /**
         * @author fenris
         */
        static chain<type_value>(members: Array<class_deferral<type_value, type_value>>): class_deferral<type_value, type_value>;
        /**
         * @author fenris
         */
        static wrap<type_input, type_output>(function_: (input: type_input) => type_output): class_deferral<type_input, type_output>;
        /**
         * @author fenris
         */
        static const_<type_value>(value: type_value): class_deferral<type_value, type_value>;
        /**
         * @author fenris
         */
        static delay<type_output>(output: type_output, delay: int): class_deferral<any, type_output>;
    }
}
declare namespace lib_plankton.call {
    /**
     * @author fenris
     */
    function convey(value: any, functions: Array<Function>): any;
    /**
     * @author fenris
     */
    function timeout(function_: () => void, delay: int): int;
    /**
     * @desc a definition for a value being "defined"
     * @author neuc
     */
    function is_def<type_value>(obj: type_value, null_is_valid?: boolean): boolean;
    /**
     * @desc returns the value if set and, when a type is specified, if the type is correct, if not return default_value
     * @author neuc
     */
    function def_val(value: any, default_value: any, type?: string, null_is_valid?: boolean): any;
    /**
     * @desc just the empty function; useful for some callbacks etc.
     * @author fenris
     */
    function nothing(): void;
    /**
     * @desc outputs
     * @author fenris
     */
    /**
     * @desc converts the "arguments"-map into an array
     * @param {Object} args
     * @author fenris
     */
    function args2list(args: any): Array<any>;
    /**
     * @desc provides the call for an attribute of a class as a regular function
     * @param {string} name the name of the attribute
     * @return {*}
     * @author fenris
     */
    function attribute<type_object, type_attribute>(name: string): (object: type_object) => type_attribute;
    /**
     * @desc provides a method of a class as a regular function
     * @param {string} name the name of the method
     * @return {function}
     * @author fenris
     */
    function method<type_object, type_output>(name: string): (object: type_object) => type_output;
    /**
     * @author fenris
     */
    type type_unival = {
        kind: string;
        data?: any;
    };
    /**
     * @author fenris
     */
    function distinguish(unival: type_unival, handlers: {
        [kind: string]: (data?: any) => any;
    }, fallback?: (unival?: type_unival) => any): any;
    /**
     * Promise version of "setTimeout"
     *
     * @author fenris
     */
    function defer<type_result>(seconds: float, action: (() => type_result)): {
        id: int;
        result: Promise<type_result>;
    };
    /**
     */
    function deferral_abort(id: int): void;
    /**
     * for rate_limit_check
     *
     * @author fenris
     */
    type type_mana_snapshot = {
        timestamp: float;
        value: float;
    };
    /**
     * rate limiting algorithm, based on the idea of mana (magic power) in video games:
     * - an actor has a fixed mana capacity, i.e. the maximum amount of available power
     * - an actor has a fixed rate of mana regeneration, i.e. how fast the power is filled up (linear growth)
     * - an action has a defined mana heft, i.e. how much power is required and deducted in order to execute it
     * - mana states are represented by snapshots, i.e. the amount of power at a certain point in time
     *
     * @author fenris
     */
    function rate_limit_check(setup: {
        capacity: float;
        regeneration_rate: float;
        get_snapshot: (() => Promise<(null | type_mana_snapshot)>);
        set_snapshot: ((snapshot: type_mana_snapshot) => Promise<void>);
        update_snapshot: ((timestamp: float, value_increment: float) => Promise<void>);
    }, heft: float): Promise<{
        granted: boolean;
        seconds: (null | float);
    }>;
}
declare namespace lib_plankton.object {
    /**
     * @author fenris
     */
    function fetch<type_value>(object: Object, fieldname: string, fallback?: type_value, escalation?: int): type_value;
    /**
     * @author fenris
     */
    function map<type_from, type_to>(object_from: {
        [key: string]: type_from;
    }, transformator: (value_from: type_from, key?: string) => type_to): {
        [key: string]: type_to;
    };
    /**
     * @desc gibt ein Objekt mit bestimmten Einträgen des Eingabe-Objekts zurück
     * @author fenris
     */
    function filter<type_value>(object_from: {
        [key: string]: type_value;
    }, predicate: (value_from: type_value, key?: string) => boolean): {
        [key: string]: type_value;
    };
    /**
     * @desc wandelt ein Array mit Einträgen der Form {key,value} in ein entsprechendes Objekt um
     * @author fenris
     */
    function from_array<type_value>(array: Array<{
        key: string;
        value: type_value;
    }>): {
        [key: string]: type_value;
    };
    /**
     * @desc wandelt ein Objekt in ein entsprechendes Array mit Einträgen der Form {key,value} um
     * @author fenris
     */
    function to_array<type_value>(object: {
        [key: string]: type_value;
    }): Array<{
        key: string;
        value: type_value;
    }>;
    /**
     * @desc gibt eine Liste von Schlüsseln eines Objekts zurück
     * @author fenris
     */
    function keys(object: {
        [key: string]: any;
    }): Array<string>;
    /**
     * @desc gibt eine Liste von Werten eines Objekts zurück
     * @author fenris
     */
    function values<type_value>(object: {
        [key: string]: type_value;
    }): Array<type_value>;
    /**
     * @desc liest ein Baum-artiges Objekt an einer bestimmten Stelle aus
     * @author fenris
     */
    function path_read<type_value>(object: Object, path: string, fallback?: type_value, escalation?: int): type_value;
    /**
     * @desc schreibt einen Wert an eine bestimmte Stelle in einem Baum-artigen Objekt
     * @author fenris
     */
    function path_write<type_value>(object: Object, path: string, value: type_value, construct?: boolean): void;
    /**
     * @desc prüft ob ein Objekt einem bestimmten Muster entspricht
     * @param {Object} object das zu prüfende Objekt
     * @param {Object} pattern das einzuhaltende Muster
     * @param {Function} connlate eine Funktion zum Feststellen der Gleichheit von Einzelwerten
     * @author fenris
     */
    function matches(object: Object, pattern: Object, collate?: typeof instance_collate): boolean;
    /**
     * @desc erzeugt eine Projektion eines Baum-artigen Objekts in ein Listen-artiges Objekt
     * @param {string} [separator] welches Zeichen als Trenner zwischen zwei Pfad-Schritten verwendet werden soll
     * @author fenris
     */
    function flatten(value: any, separator?: string, key_for_element?: (index: int) => string): Object;
    /**
     * @author fenris
     */
    function clash(x: {
        [key: string]: any;
    }, y: {
        [key: string]: any;
    }, { "overwrite": overwrite, "hooks": { "existing": hook_existing, }, }?: {
        overwrite?: boolean;
        hooks?: {
            existing?: (key?: string, value_old?: any, value_new?: any) => void;
        };
    }): {
        [key: string]: any;
    };
    /**
     * @author fenris
     */
    function patch(core: Object, mantle: Object, deep?: boolean, path?: string): void;
    /**
     * @author fenris
     */
    function patched(core: Object, mantle: Object, deep?: boolean): Object;
    /**
     * @author fenris
     */
    function attached(object: Object, key: string, value: any): Object;
    /**
     * @author fenris
     */
    function copy(object: Object): Object;
}
declare namespace lib_plankton.log {
    /**
     */
    enum enum_level {
        debug = 0,
        info = 1,
        notice = 2,
        warning = 3,
        error = 4
    }
    /**
     */
    function level_order(level1: enum_level, level2: enum_level): boolean;
    /**
     */
    function level_show(level: enum_level): string;
    /**
     */
    type type_entry = {
        level: enum_level;
        incident: string;
        details: Record<string, any>;
    };
}
/**
 * @deprecated
 * @todo remove
 */
declare namespace lib_plankton.log {
    function level_push(level: int): void;
    function level_pop(): void;
    function indent_push(indent: int): void;
    function indent_pop(): void;
    function indent_inc(): void;
    function indent_dec(): void;
    /**
     * @author fenris
     */
    function write({ "message": message, "type": type, "prefix": prefix, "level": level, "indent": indent, }: {
        message?: string;
        type?: string;
        prefix?: string;
        level?: int;
        indent?: int;
    }): void;
}
declare namespace lib_plankton.log {
    /**
     */
    abstract class class_channel {
        /**
         */
        abstract add(entry: type_entry): void;
    }
}
declare namespace lib_plankton.log {
    /**
     * output for writing log entries to stdout
     */
    class class_channel_stdout extends class_channel {
        /**
         */
        add(entry: type_entry): void;
    }
}
declare namespace lib_plankton.log {
    /**
     */
    class class_channel_file extends class_channel {
        /**
         * the path of the log file
         */
        private path;
        /**
         * [constructor]
         */
        constructor(path: string);
        /**
         */
        add(entry: type_entry): void;
    }
}
declare namespace lib_plankton.log {
    /**
     * output for desktop notifications via "libnotify"
     */
    class class_channel_notify extends class_channel {
        /**
         */
        add(entry: type_entry): void;
    }
}
declare namespace lib_plankton.log {
    /**
     * decorator for filtering out log entries below a certain level threshold
     */
    class class_channel_minlevel extends class_channel {
        /**
         */
        private core;
        /**
         */
        private threshold;
        /**
         */
        constructor(core: class_channel, threshold: enum_level);
        /**
         */
        add(entry: type_entry): void;
    }
}
declare namespace lib_plankton.log {
    /**
     */
    function channel_make(description: {
        kind: string;
        data?: {
            [key: string]: any;
        };
    }): class_channel;
    /**
     */
    type type_configuration = Array<class_channel>;
    /**
     */
    function conf_default(): type_configuration;
}
declare namespace lib_plankton.log {
    /**
     * pushes a new configuration on the stack and activates it
     */
    function conf_push(channels: type_configuration): void;
    /**
     * pops the current active configuration from the stack
     */
    function conf_pop(): void;
    /**
     * consumes a log entry, i.e. sends it to the currently active outputs
     */
    function add(entry: type_entry): void;
    /**
     */
    function debug(incident: string, details?: Record<string, any>): void;
    /**
     */
    function info(incident: string, details?: Record<string, any>): void;
    /**
     */
    function notice(incident: string, details?: Record<string, any>): void;
    /**
     */
    function warning(incident: string, details?: Record<string, any>): void;
    /**
     */
    function error(incident: string, details?: Record<string, any>): void;
}
declare var plain_text_to_html: (text: string) => string;
/**
 * @desc makes a valid
 */
declare var format_sentence: (str: string, rtl?: boolean, caseSense?: boolean) => string;
declare var fill_string_template: (template_string: string, object: any, fabric: Function, delimiter: string, default_string: string, sloppy: boolean) => string;
declare var make_string_template: (_template: string, _fabrics?: Object) => (object: {
    [key: string]: string;
}) => string;
declare var make_eml_header: (object: {
    [key: string]: string;
}) => string;
declare var make_eml_body: Object;
declare namespace lib_plankton.string {
    /**
     * @author neuc,frac
     */
    function empty(str: string): boolean;
    /**
     * @desc returns a unique string
     * @param {string} prefix an optional prefix for the generated string
     * @return {string}
     * @author fenris
     */
    function generate(prefix?: string): string;
    /**
     * @author fenris
     */
    function join(parts: Array<string>, glue?: string): string;
    /**
     * @desc splits a string, but returns an empty list, if the string is empty
     * @param {string} chain
     * @param {string} separator
     * @return {Array<string>}
     * @author fenris
     */
    function split(chain: string, separator?: string): Array<string>;
    /**
     * @author neu3no
     */
    function explode(str: string, needle: string, max: int): Array<string>;
    /**
     * @desc concats a given word with itself n times
     * @param {string} word
     * @param {int}
     * @return {string}
     * @author fenris
     */
    function repeat(word: string, count: int): string;
    /**
     * @desc lengthens a string by repeatedly appending or prepending another string
     * @param {string} word the string to pad
     * @param {int} length the length, which the result shall have
     * @param {string} symbol the string, which will be added (multiple times)
     * @param {boolean} [prepend]; whether to prepend (~true) or append (~false); default: false
     * @return {string} the padded string
     * @author fenris
     */
    function pad(word: string, length: int, symbol?: string, mode?: string): string;
    /**
     * @desc checks if a given string conttains a certain substring
     * @param {string} string
     * @param {string} part
     * @return {boolean}
     * @author fenris
     */
    function contains(chain: string, part: string): boolean;
    /**
     * @desc checks if a given string starts with a certain substring
     * @param {string} string
     * @param {string} part
     * @return {boolean}
     * @author fenris
     */
    function startsWith(chain: string, part: string): boolean;
    /**
     * @desc checks if a given string ends with a certain substring
     * @param {string} string
     * @param {string} part
     * @return {boolean}
     * @author fenris
     */
    function endsWith(chain: string, part: string): boolean;
    /**
     * @desc count the occourrences of a string in a string
     * @param string haystack_string the string wich should be examined
     * @param string needle_string the string which should be counted
     * @author neuc
     */
    function count_occourrences(haystack_string: string, needle_string: string, check_escape: boolean): int;
    /**
     * @author fenris
     */
    function replace(str: string, replacements: Array<{
        from: string;
        to: string;
    }>, options?: {}): string;
    /**
     * @desc replaces occurences of "{{name}}" in a string by the corresponding values of an argument object
     * @author fenris
     */
    function coin(str: string, args: {
        [id: string]: string;
    }, options?: {
        legacy?: boolean;
        open?: string;
        close?: string;
    }): string;
    /**
     * @author fenris
     * @deprecated use limit
     */
    function cut(str: string, length: int, delimiter?: string): string;
    /**
     */
    function limit(str: string, options?: {
        length?: int;
        indicator?: string;
    }): string;
    /**
     */
    function slice(str: string, size: int): Array<string>;
}
/**
 * @deprecated
 */
declare namespace lib_string {
    const empty: typeof lib_plankton.string.empty;
    const generate: typeof lib_plankton.string.generate;
    const split: typeof lib_plankton.string.split;
    const explode: typeof lib_plankton.string.repeat;
    const repeat: typeof lib_plankton.string.repeat;
    const pad: typeof lib_plankton.string.pad;
    const contains: typeof lib_plankton.string.contains;
    const startsWith: typeof lib_plankton.string.startsWith;
    const endsWith: typeof lib_plankton.string.endsWith;
    const count_occourrences: typeof lib_plankton.string.count_occourrences;
    const coin: typeof lib_plankton.string.coin;
    const stance: typeof lib_plankton.string.coin;
    const cut: typeof lib_plankton.string.cut;
}
declare namespace lib_plankton.string {
    /**
     * an implementation of c sprintf
     * @param {string} string format string
     * @param {array} args arguments which should be filled into
     * @returns {string}
     */
    var sprintf: (input: string, args?: Array<any>, original?: any) => string;
    /**
     * an implementation of c printf
     * @param {string} string format string
     * @param {array} args arguments which should be filled into
     * @returns {string}
     */
    function printf(format: any, args: any): void;
}
declare var sprintf: (input: string, args?: Array<any>, original?: any) => string;
declare var printf: typeof lib_plankton.string.printf;
declare var eml_log: any;
declare var track_exports: any;
declare var make_logger: (prefix: any, current_loglevel: any) => (obj: any, lvl: any) => void;
declare namespace lib_plankton.sha256 {
    /**
     * @author fenris
     */
    function get(value: string, secret?: string): string;
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    interface interface_code<type_from, type_to> {
        /**
         * @author fenris
         */
        encode(x: type_from): type_to;
        /**
         * @author fenris
         */
        decode(x: type_to): type_from;
    }
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    type type_code<type_from, type_to> = {
        /**
         * @author fenris
         */
        encode: (x: type_from) => type_to;
        /**
         * @author fenris
         */
        decode: (x: type_to) => type_from;
    };
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    function inverse_encode<type_from, type_to>(decode: (to: type_to) => type_from, to: type_to): type_from;
    /**
     * @author fenris
     */
    function inverse_decode<type_from, type_to>(encode: (from: type_from) => type_to, from: type_from): type_to;
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    class class_code_inverse<type_from, type_to> implements interface_code<type_to, type_from> {
        /**
         * @author fenris
         */
        protected subject: interface_code<type_from, type_to>;
        /**
         * @author fenris
         */
        constructor(subject: interface_code<type_from, type_to>);
        /**
         * @implementation
         * @author fenris
         */
        encode(to: type_to): type_from;
        /**
         * @implementation
         * @author fenris
         */
        decode(from: type_from): type_to;
    }
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    function pair_encode<type_from, type_between, type_to>(encode_first: (from: type_from) => type_between, encode_second: (between: type_between) => type_to, from: type_from): type_to;
    /**
     * @author fenris
     */
    function pair_decode<type_from, type_between, type_to>(decode_first: (between: type_between) => type_from, decode_second: (to: type_to) => type_between, to: type_to): type_from;
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    class class_code_pair<type_from, type_between, type_to> implements interface_code<type_from, type_to> {
        /**
         * @author fenris
         */
        protected first: interface_code<type_from, type_between>;
        /**
         * @author fenris
         */
        protected second: interface_code<type_between, type_to>;
        /**
         * @author fenris
         */
        constructor(first: interface_code<type_from, type_between>, second: interface_code<type_between, type_to>);
        /**
         * @implementation
         * @author fenris
         */
        encode(from: type_from): type_to;
        /**
         * @implementation
         * @author fenris
         */
        decode(to: type_to): type_from;
    }
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    function chain_encode(encode_links: Array<(from: any) => any>, from: any): any;
    /**
     * @author fenris
     */
    function chain_decode(decode_links: Array<(to: any) => any>, to: any): any;
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    class class_code_chain implements interface_code<any, any> {
        /**
         * @author fenris
         */
        protected links: Array<interface_code<any, any>>;
        /**
         * @author fenris
         */
        constructor(links: Array<interface_code<any, any>>);
        /**
         * @implementation
         * @author fenris
         */
        encode(from: any): any;
        /**
         * @implementation
         * @author fenris
         */
        decode(to: any): any;
    }
}
declare namespace lib_plankton.code {
    /**
     * @author Christian Fraß <frass@greenscale.de>
     */
    type type_flatten_from = Array<{
        [name: string]: any;
    }>;
    /**
     * @author Christian Fraß <frass@greenscale.de>
     */
    type type_flatten_to = {
        keys: Array<string>;
        data: Array<Array<any>>;
    };
    /**
     * @author Christian Fraß <frass@greenscale.de>
     */
    function flatten_encode(from: type_flatten_from, keys?: Array<string>): type_flatten_to;
    /**
     * @author Christian Fraß <frass@greenscale.de>
     */
    function flatten_decode(to: type_flatten_to): type_flatten_from;
}
declare namespace lib_plankton.code {
    /**
     * @author fenris
     */
    class class_code_flatten implements interface_code<type_flatten_from, type_flatten_to> {
        /**
         * @author fenris
         */
        constructor();
        /**
         * @implementation
         * @author fenris
         */
        encode(x: type_flatten_from): type_flatten_to;
        /**
         * @implementation
         * @author fenris
         */
        decode(x: type_flatten_to): type_flatten_from;
    }
}
declare namespace lib_plankton.json {
    /**
     * @author fenris
     */
    function encode(x: any, formatted?: boolean): string;
    /**
     * @author fenris
     */
    function decode(x: string): any;
}
declare namespace lib_plankton.json {
    /**
     * @author fenris
     */
    class class_json implements lib_plankton.code.interface_code<any, string> {
        /**
         * @author fenris
         */
        constructor();
        /**
         * @implementation
         * @author fenris
         */
        encode(x: any): string;
        /**
         * @implementation
         * @author fenris
         */
        decode(x: string): any;
    }
}
declare namespace lib_plankton.file {
    /**
     * @author fenris
     */
    function read(path: string): Promise<string>;
    /**
     * @author fenris
     */
    function read_buffer(path: string): Promise<Buffer>;
    /**
     * @author fenris
     */
    function read_stdin(): Promise<string>;
    /**
     * @author fenris
     */
    function write(path: string, content: string, options?: {
        encoding?: string;
    }): Promise<void>;
    /**
     * @author fenris
     */
    function write_buffer(path: string, content: Buffer, options?: {}): Promise<void>;
    /**
     */
    function delete_(path: string): Promise<void>;
}
declare namespace lib_plankton.translate {
    /**
     * @author fenris
     */
    type type_package_meta = {
        identifier: string;
        name?: string;
    };
    /**
     * @author fenris
     */
    type type_package = {
        meta: type_package_meta;
        tree: {
            [id: string]: string;
        };
    };
    /**
     * @desc the level of verbosity, specifiying how much output the system shall provide about its actions
     * @author fenris
     */
    var _verbosity: int;
    /**
     * @desc moves a language to the top of the order, making it the primary one
     * @author fenris
     */
    function promote(identifier: string): void;
    /**
     * @desc adds a package to the sytem
     * @author fenris
     */
    function add(package_: type_package): void;
    /**
     * @desc integrates a package to the system, i.e. creates a new one if none existed so far or merges with an existing one
     * @author fenris
     */
    function feed(package_: type_package): void;
    /**
     * @desc tries to retrieve a translation for a specific package identifier
     * @author fenris
     */
    function fetch(identifier: string, path: string, args?: {
        [id: string]: string;
    }): lib_plankton.pod.type_pod<string>;
    /**
     * @desc retrieves a string by going through the order and trying to fetch it for the current entry
     * @author fenris
     */
    function get(path: string, args?: {
        [id: string]: string;
    }, fallback?: string): string;
    /**
     * @author fenris
     */
    function list(): Array<type_package_meta>;
    /**
     * @author fenris
     * @todo get rid of this; it's currenly needed only for the cdh-internal lib_completion
     */
    function paths(): Array<string>;
    /**
     * @author fenris
     */
    function initialize_promise({ "logprefix": logprefix, "verbosity": verbosity, "packages": packages, "order": order, "autopromote": autopromote, }?: {
        logprefix?: string;
        verbosity?: int;
        packages?: Array<type_package>;
        order?: Array<string>;
        autopromote?: boolean;
    }): lib_plankton.call.type_promise<void, Error>;
    /**
     * @author fenris
     */
    function initialize_executor(stuff?: any): lib_plankton.call.type_executor<void, Error>;
    /**
     * @author fenris
     */
    function initialize(stuff?: any): lib_plankton.call.type_executor<void, Error>;
}
declare namespace lib_plankton.translate {
    /**
     * @author fenris
     */
    function iso_639_1_to_iso_639_2(iso6391: string): string;
    /**
     * @author fenris
     */
    function stance(str: string): string;
}
declare namespace lib_plankton.args {
    /**
     */
    enum enum_environment {
        cli = "cli",
        url = "url"
    }
    /**
     */
    enum enum_kind {
        positional = "positional",
        volatile = "volatile"
    }
    /**
     */
    enum enum_type {
        boolean = "boolean",
        integer = "int",
        float = "float",
        string = "string"
    }
    /**
     */
    enum enum_mode {
        replace = "replace",
        accumulate = "accumulate"
    }
}
declare namespace lib_plankton.args {
    /**
     * @author fenris
     */
    class class_argument {
        /**
         * @author fenris
         */
        protected name: string;
        /**
         * @author fenris
         */
        protected kind: enum_kind;
        /**
         * @author fenris
         */
        protected type: enum_type;
        /**
         * @author fenris
         */
        protected mode: enum_mode;
        /**
         * @author fenris
         */
        protected default_: any;
        /**
         * @author fenris
         */
        protected info: string;
        /**
         * @author fenris
         */
        protected parameters: Object;
        /**
         * @author fenris
         */
        protected hidden: boolean;
        /**
         * @author fenris
         */
        constructor({ "name": name, "type": type, "kind": kind, "mode": mode, "default": default_, "info": info, "parameters": parameters, "hidden": hidden, }: {
            name: string;
            type?: enum_type;
            kind?: enum_kind;
            mode?: enum_mode;
            default?: any;
            info?: string;
            parameters?: Object;
            hidden?: boolean;
        });
        /**
         * @author fenris
         */
        static positional({ "name": name, "type": type, "mode": mode, "default": default_, "info": info, "hidden": hidden, "index": index, }: {
            name: string;
            type?: enum_type;
            mode?: enum_mode;
            default?: any;
            info?: string;
            hidden?: boolean;
            index: int;
        }): class_argument;
        /**
         * @author fenris
         */
        static volatile({ "name": name, "type": type, "mode": mode, "default": default_, "info": info, "hidden": hidden, "indicators_short": indicators_short, "indicators_long": indicators_long, }: {
            name: string;
            type?: enum_type;
            mode?: enum_mode;
            default?: any;
            info?: string;
            hidden?: boolean;
            indicators_short: Array<string>;
            indicators_long: Array<string>;
        }): class_argument;
        /**
         * @author fenris
         */
        check(): boolean;
        /**
         * @author fenris
         */
        name_get(): string;
        /**
         * @author fenris
         */
        kind_get(): enum_kind;
        /**
         * @author fenris
         */
        type_get(): enum_type;
        /**
         * @author fenris
         */
        mode_get(): enum_mode;
        /**
         * @author fenris
         */
        default_get(): any;
        /**
         * @author fenris
         */
        parameters_get(): Object;
        /**
         * @author fenris
         */
        hidden_get(): boolean;
        /**
         * @author fenris
         */
        toString(): string;
        /**
         * @author fenris
         */
        indicator_main(): string;
        /**
         * @author fenris
         */
        pattern_value(): string;
        /**
         * @author fenris
         */
        extract(raw: string): any;
        /**
         * @author fenris
         */
        assign(data: Object, target: string, raw: string): void;
        /**
         * @author fenris
         */
        make(data: Object, target: string): string;
        /**
         * @author fenris
         */
        generate_help(): string;
    }
}
declare namespace lib_plankton.args {
    /**
     * @author fenris
     */
    var verbosity: int;
    /**
     * @author fenris
     * @todo check validity
     */
    class class_handler {
        /**
         * @author fenris
         */
        protected arguments_: {
            [name: string]: class_argument;
        };
        /**
         * @author fenris
         */
        constructor(arguments_: {
            [name: string]: class_argument;
        });
        /**
         * @author fenris
         */
        filter(kind: enum_kind): {
            [name: string]: class_argument;
        };
        /**
         * @author fenris
         */
        read(environment: enum_environment, input: string, data?: {
            [name: string]: any;
        }): {
            [name: string]: any;
        };
        /**
         * @author fenris
         * @todo handle if the data object doesn't have the required field or the type is wrong or sth.
         */
        write(environment: enum_environment, data: {
            [name: string]: any;
        }): string;
        /**
         * @desc manpage-like info-sheet
         * @author fenris
         */
        generate_help({ "programname": programname, "author": author, "description": description, "executable": executable, }: {
            programname?: string;
            author?: string;
            description?: string;
            executable?: string;
        }): string;
    }
}
declare namespace lib_plankton.http {
    /**
     * @author fenris <frass@greenscale.de>
     */
    enum enum_method {
        get = "get",
        post = "post",
        patch = "patch",
        put = "put",
        delete = "delete",
        options = "options",
        head = "head"
    }
    /**
     * @author fenris <frass@greenscale.de>
     */
    type type_request = {
        scheme: ("http" | "https");
        host: (null | string);
        path: string;
        version: string;
        method: enum_method;
        query: (null | string);
        headers: Record<string, string>;
        body: (null | Buffer);
    };
    /**
     * @author fenris <frass@greenscale.de>
     */
    type type_response = {
        version: (null | string);
        status_code: int;
        headers: Record<string, string>;
        body: Buffer;
    };
}
declare namespace lib_plankton.http {
    /**
     * @author fenris <frass@greenscale.de>
     */
    function encode_method(method: enum_method): string;
    /**
     * @author fenris <frass@greenscale.de>
     */
    function encode_request(request: type_request): string;
    /**
     * @author fenris <frass@greenscale.de>
     */
    function decode_request(request_raw: string): type_request;
    /**
     * @author fenris <frass@greenscale.de>
     */
    function encode_response(response: type_response): string;
    /**
     * @author fenris <frass@greenscale.de>
     */
    function decode_response(response_raw: string): type_response;
    /**
     * executes an HTTP request
     *
     * @todo define type_signal
     */
    function call(request: type_request, options?: {
        timeout?: (null | float);
        follow_redirects?: boolean;
        implementation?: ("fetch" | "http_module");
    }): Promise<type_response>;
}
declare namespace lib_plankton.http {
    /**
     * @author fenris
     */
    class class_http_request implements lib_plankton.code.interface_code<type_request, string> {
        /**
         * @author fenris
         */
        constructor();
        /**
         * @implementation
         * @author fenris
         */
        encode(x: type_request): string;
        /**
         * @implementation
         * @author fenris
         */
        decode(x: string): type_request;
    }
    /**
     * @author fenris
     */
    class class_http_response implements lib_plankton.code.interface_code<type_response, string> {
        /**
         * @author fenris
         */
        constructor();
        /**
         * @implementation
         * @author fenris
         */
        encode(x: type_response): string;
        /**
         * @implementation
         * @author fenris
         */
        decode(x: string): type_response;
    }
}
declare namespace lib_plankton.sqlite {
    /**
     */
    type type_query_raw = {
        template: string;
        arguments: Record<string, any>;
    };
    /**
     */
    type type_connection = {
        handle: any;
    };
    /**
     */
    function get_connection(database_path: string): Promise<type_connection>;
    /**
     */
    function drop_connection(connection: type_connection): Promise<void>;
    /**
     * for CREATE TABLE, DROP TABLE, etc.
     */
    function query_set(connection: type_connection, query_raw: type_query_raw): Promise<any>;
    /**
     * for INSERT, UPDATE, DELETE
     */
    function query_put(connection: type_connection, query_raw: type_query_raw): Promise<{
        id: (null | number);
        affected: (null | number);
    }>;
    /**
     * for SELECT
     *
     * @todo rather use handle procedure for rows instead of returning an array
     */
    function query_get(connection: type_connection, query_raw: type_query_raw): Promise<Array<Record<string, any>>>;
    /**
     * for SELECT
     *
     * @todo rather use handle procedure for rows instead of returning an array
     */
    function query_probe(connection: type_connection, query_raw: type_query_raw, handler: ((row: Record<string, any>) => void)): void;
}
